package org.apache.tools.ant;

import java.io.File;
import java.util.Vector;

import SevenZip.LzmaAlone;

/**
 * @author Jean Lycoops
 * Bansions 33
 * B-4845 Sart-lez-Spa
 * Belgium
 * 7z-apache-ant@pharmasoft.be
 */
public class SevenZip extends Task {
	private String input;
	private String output;
	private static final int ENCODE = 0;
	private static final int DECODE = 1;
	private static final int BENCHMARK = 2;
	private static final int NONE = -1;
	private String a;
	private String d;
	private String fb;
	private String lc;
	private String lp;
	private String pb;
	private String mf;
	private String eos;
	private static final String[] TASKS = { "encode", "decode", "benchmark" };
	private static final String[] MATCH_FINDERS = { "bt2", "bt4", "bt4b" };
	private int task;
	public SevenZip() {
		super();
		this.input = null;
		this.output = null;
		this.task = NONE;
		this.a = null;
		this.d = null;
		this.fb = null;
		this.lc = null;
		this.lp = null;
		this.pb = null;
		this.mf = null;
		this.eos = null;
	}
	private void parseInt(String value, String tag, String switch_, int min, int max, Vector args) throws BuildException {
		if (value == null) return;
		try {
			Integer parsed = new Integer(value);
			if ((parsed.intValue() < min) || (parsed.intValue() > max))
				throw new BuildException(tag + " out if range [" + min + "-" + max + "]");
			args.addElement(switch_ + value);
		} catch (NumberFormatException numberFormatException) {
			new BuildException(tag + " is'nt a numeric");
		}
	}
	private void parseMatchfinder(String value, Vector args) throws BuildException {
		if (value == null) return;
		for (int i=0; i<MATCH_FINDERS.length; i++) {
			if (MATCH_FINDERS[i].equalsIgnoreCase(value)) {
				args.addElement("-mf" + value);
				return;
			}
		} 
		throw new BuildException("unvalid match finder : " + value);
	}
    public void execute() {
    	this.log("LZMA# 4.12 beta Copyright (c) 1999-2004 Igor Pavlov  2004-12-10");
    	this.log("JAVA LZMA Encoder 4.12  myspace");
    	long timestamp = System.currentTimeMillis();
		Vector vargs = new Vector();
        if (this.task == NONE) throw new BuildException("work requested.");
        vargs.addElement(TASKS[this.task].substring(0, 1));
        if (this.input == null) throw new BuildException("input requested.");
        if (this.output == null) throw new BuildException("output requested.");
        if (!new File(this.input).exists()) throw new BuildException("input does'nt exists.");
       	this.parseInt(this.a, "mode", "-a", 0, 2, vargs);
       	this.parseInt(this.d, "dictionnary", "-d", 0, 28, vargs);
       	this.parseInt(this.fb, "fastbytes", "-fb", 5, 255, vargs);
       	this.parseInt(this.lc, "litteralcontextbits", "-lc", 0, 8, vargs);
       	this.parseInt(this.lp, "litteralposbits", "-lp", 0, 4, vargs);
       	this.parseInt(this.pb, "posbits", "-pb", 0, 4, vargs);
       	this.parseMatchfinder(this.mf, vargs);
       	if (this.eos != null) vargs.addElement("-eos");
        vargs.addElement(this.input);
        vargs.addElement(this.output);
        String[] args = new String[vargs.size()];
		//String[] args = new String[vargs.size()+1];
        for (int arg=0; arg<vargs.size(); arg++) {
        	args[arg] = (String)vargs.elementAt(arg);
        }
		//args[vargs.size()] = "-mx=9";
        try {
        	this.log(vargs.toString());
        	LzmaAlone.main2(args);
        	long duration = System.currentTimeMillis() - timestamp;
        	if (duration > 9999) {
        		this.log("time : " + (duration / 1000) + " s");        	
        	} else {
        		this.log("time : " + duration + " ms");        	
        	}

        } catch (Exception exception) {
        	throw new BuildException(exception);
        }
    }
	public void setTask(String task) {
		for (int i=0; i<TASKS.length; i++) {
			if (task.trim().equalsIgnoreCase(TASKS[i])) this.task = i;
		}
	}
	public void setOutput(String output) {
		this.output = output.trim();
	}
	public void setInput(String input) {
		this.input = input.trim();
	}
	public void setMode(String mode) {
		this.a = mode.trim();
	}
	public void setDictionnary(String dictionnary) {
		this.d = dictionnary.trim();
	}
	public void setFastbytes(String fastbytes) {
		this.fb = fastbytes.trim();
	}
	public void setLiteralcontextbits(String literalcontextbits) {
		this.lc = literalcontextbits;
	}
	public void setLiteralposbits(String literalposbits) {
		this.lp = literalposbits.trim();
	}
	public void setPosbits(String posbits) {
		this.pb = posbits.trim();
	}
	public void setMatchfinder(String matchfinder) {
		this.mf = matchfinder.trim();
	}
	public void setEndofstreammarker(String endofstreammarker) {
		this.eos = "true";
	}
}
